/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository;

import edu.kit.ipd.descartes.core.Entity;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Signature</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature#getParameters <em>Parameters</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature#getReturnType <em>Return Type</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature#getInterface <em>Interface</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getSignature()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='ParametersMustHaveUniqueNames'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot ParametersMustHaveUniqueNames='self.parameters->isUnique(p : Parameter | p.name)'"
 * @generated
 */
public interface Signature extends Entity {
	/**
	 * Returns the value of the '<em><b>Parameters</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.repository.Parameter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameters</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameters</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getSignature_Parameters()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<Parameter> getParameters();

	/**
	 * Returns the value of the '<em><b>Return Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Return Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Return Type</em>' reference.
	 * @see #setReturnType(DataType)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getSignature_ReturnType()
	 * @model
	 * @generated
	 */
	DataType getReturnType();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature#getReturnType <em>Return Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Return Type</em>' reference.
	 * @see #getReturnType()
	 * @generated
	 */
	void setReturnType(DataType value);

	/**
	 * Returns the value of the '<em><b>Interface</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface#getSignatures <em>Signatures</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interface</em>' container reference.
	 * @see #setInterface(Interface)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getSignature_Interface()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface#getSignatures
	 * @model opposite="signatures" required="true" transient="false"
	 * @generated
	 */
	Interface getInterface();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature#getInterface <em>Interface</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interface</em>' container reference.
	 * @see #getInterface()
	 * @generated
	 */
	void setInterface(Interface value);

} // Signature
