/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceRequiringRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>External Call</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ExternalCallImpl#getSignature <em>Signature</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ExternalCallImpl#getInterfaceRequiringRole <em>Interface Requiring Role</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ExternalCallImpl extends EntityImpl implements ExternalCall {
	/**
	 * The cached value of the '{@link #getSignature() <em>Signature</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSignature()
	 * @generated
	 * @ordered
	 */
	protected Signature signature;

	/**
	 * The cached value of the '{@link #getInterfaceRequiringRole() <em>Interface Requiring Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceRequiringRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceRequiringRole interfaceRequiringRole;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalCallImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.EXTERNAL_CALL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Signature getSignature() {
		if (signature != null && signature.eIsProxy()) {
			InternalEObject oldSignature = (InternalEObject)signature;
			signature = (Signature)eResolveProxy(oldSignature);
			if (signature != oldSignature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServicebehaviorPackage.EXTERNAL_CALL__SIGNATURE, oldSignature, signature));
			}
		}
		return signature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signature basicGetSignature() {
		return signature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSignature(Signature newSignature) {
		Signature oldSignature = signature;
		signature = newSignature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.EXTERNAL_CALL__SIGNATURE, oldSignature, signature));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public InterfaceRequiringRole getInterfaceRequiringRole() {
		if (interfaceRequiringRole != null && interfaceRequiringRole.eIsProxy()) {
			InternalEObject oldInterfaceRequiringRole = (InternalEObject)interfaceRequiringRole;
			interfaceRequiringRole = (InterfaceRequiringRole)eResolveProxy(oldInterfaceRequiringRole);
			if (interfaceRequiringRole != oldInterfaceRequiringRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServicebehaviorPackage.EXTERNAL_CALL__INTERFACE_REQUIRING_ROLE, oldInterfaceRequiringRole, interfaceRequiringRole));
			}
		}
		return interfaceRequiringRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceRequiringRole basicGetInterfaceRequiringRole() {
		return interfaceRequiringRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInterfaceRequiringRole(InterfaceRequiringRole newInterfaceRequiringRole) {
		InterfaceRequiringRole oldInterfaceRequiringRole = interfaceRequiringRole;
		interfaceRequiringRole = newInterfaceRequiringRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.EXTERNAL_CALL__INTERFACE_REQUIRING_ROLE, oldInterfaceRequiringRole, interfaceRequiringRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.EXTERNAL_CALL__SIGNATURE:
				if (resolve) return getSignature();
				return basicGetSignature();
			case ServicebehaviorPackage.EXTERNAL_CALL__INTERFACE_REQUIRING_ROLE:
				if (resolve) return getInterfaceRequiringRole();
				return basicGetInterfaceRequiringRole();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.EXTERNAL_CALL__SIGNATURE:
				setSignature((Signature)newValue);
				return;
			case ServicebehaviorPackage.EXTERNAL_CALL__INTERFACE_REQUIRING_ROLE:
				setInterfaceRequiringRole((InterfaceRequiringRole)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.EXTERNAL_CALL__SIGNATURE:
				setSignature((Signature)null);
				return;
			case ServicebehaviorPackage.EXTERNAL_CALL__INTERFACE_REQUIRING_ROLE:
				setInterfaceRequiringRole((InterfaceRequiringRole)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.EXTERNAL_CALL__SIGNATURE:
				return signature != null;
			case ServicebehaviorPackage.EXTERNAL_CALL__INTERFACE_REQUIRING_ROLE:
				return interfaceRequiringRole != null;
		}
		return super.eIsSet(featureID);
	}

} //ExternalCallImpl
