/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.deployment;

import edu.kit.ipd.descartes.core.CorePackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.deployment.DeploymentFactory
 * @model kind="package"
 * @generated
 */
public interface DeploymentPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "deployment";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes-research.net/metamodel/deployment/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "deployment";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DeploymentPackage eINSTANCE = edu.kit.ipd.descartes.mm.deployment.impl.DeploymentPackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.deployment.impl.DeploymentImpl <em>Deployment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.deployment.impl.DeploymentImpl
	 * @see edu.kit.ipd.descartes.mm.deployment.impl.DeploymentPackageImpl#getDeployment()
	 * @generated
	 */
	int DEPLOYMENT = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>System</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT__SYSTEM = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target Resource Landscape</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT__TARGET_RESOURCE_LANDSCAPE = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Deployment Contexts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT__DEPLOYMENT_CONTEXTS = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Deployment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.deployment.impl.DeploymentContextImpl <em>Context</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.deployment.impl.DeploymentContextImpl
	 * @see edu.kit.ipd.descartes.mm.deployment.impl.DeploymentPackageImpl#getDeploymentContext()
	 * @generated
	 */
	int DEPLOYMENT_CONTEXT = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_CONTEXT__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_CONTEXT__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Deployment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_CONTEXT__DEPLOYMENT = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Assembly Context</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_CONTEXT__ASSEMBLY_CONTEXT = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Resource Container</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_CONTEXT__RESOURCE_CONTAINER = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Context</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_CONTEXT_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;


	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.deployment.Deployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Deployment</em>'.
	 * @see edu.kit.ipd.descartes.mm.deployment.Deployment
	 * @generated
	 */
	EClass getDeployment();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.deployment.Deployment#getSystem <em>System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>System</em>'.
	 * @see edu.kit.ipd.descartes.mm.deployment.Deployment#getSystem()
	 * @see #getDeployment()
	 * @generated
	 */
	EReference getDeployment_System();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.deployment.Deployment#getTargetResourceLandscape <em>Target Resource Landscape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target Resource Landscape</em>'.
	 * @see edu.kit.ipd.descartes.mm.deployment.Deployment#getTargetResourceLandscape()
	 * @see #getDeployment()
	 * @generated
	 */
	EReference getDeployment_TargetResourceLandscape();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.deployment.Deployment#getDeploymentContexts <em>Deployment Contexts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Deployment Contexts</em>'.
	 * @see edu.kit.ipd.descartes.mm.deployment.Deployment#getDeploymentContexts()
	 * @see #getDeployment()
	 * @generated
	 */
	EReference getDeployment_DeploymentContexts();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.deployment.DeploymentContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Context</em>'.
	 * @see edu.kit.ipd.descartes.mm.deployment.DeploymentContext
	 * @generated
	 */
	EClass getDeploymentContext();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.deployment.DeploymentContext#getDeployment <em>Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Deployment</em>'.
	 * @see edu.kit.ipd.descartes.mm.deployment.DeploymentContext#getDeployment()
	 * @see #getDeploymentContext()
	 * @generated
	 */
	EReference getDeploymentContext_Deployment();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.deployment.DeploymentContext#getAssemblyContext <em>Assembly Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Assembly Context</em>'.
	 * @see edu.kit.ipd.descartes.mm.deployment.DeploymentContext#getAssemblyContext()
	 * @see #getDeploymentContext()
	 * @generated
	 */
	EReference getDeploymentContext_AssemblyContext();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.deployment.DeploymentContext#getResourceContainer <em>Resource Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Resource Container</em>'.
	 * @see edu.kit.ipd.descartes.mm.deployment.DeploymentContext#getResourceContainer()
	 * @see #getDeploymentContext()
	 * @generated
	 */
	EReference getDeploymentContext_ResourceContainer();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	DeploymentFactory getDeploymentFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.deployment.impl.DeploymentImpl <em>Deployment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.deployment.impl.DeploymentImpl
		 * @see edu.kit.ipd.descartes.mm.deployment.impl.DeploymentPackageImpl#getDeployment()
		 * @generated
		 */
		EClass DEPLOYMENT = eINSTANCE.getDeployment();

		/**
		 * The meta object literal for the '<em><b>System</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPLOYMENT__SYSTEM = eINSTANCE.getDeployment_System();

		/**
		 * The meta object literal for the '<em><b>Target Resource Landscape</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPLOYMENT__TARGET_RESOURCE_LANDSCAPE = eINSTANCE.getDeployment_TargetResourceLandscape();

		/**
		 * The meta object literal for the '<em><b>Deployment Contexts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPLOYMENT__DEPLOYMENT_CONTEXTS = eINSTANCE.getDeployment_DeploymentContexts();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.deployment.impl.DeploymentContextImpl <em>Context</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.deployment.impl.DeploymentContextImpl
		 * @see edu.kit.ipd.descartes.mm.deployment.impl.DeploymentPackageImpl#getDeploymentContext()
		 * @generated
		 */
		EClass DEPLOYMENT_CONTEXT = eINSTANCE.getDeploymentContext();

		/**
		 * The meta object literal for the '<em><b>Deployment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPLOYMENT_CONTEXT__DEPLOYMENT = eINSTANCE.getDeploymentContext_Deployment();

		/**
		 * The meta object literal for the '<em><b>Assembly Context</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPLOYMENT_CONTEXT__ASSEMBLY_CONTEXT = eINSTANCE.getDeploymentContext_AssemblyContext();

		/**
		 * The meta object literal for the '<em><b>Resource Container</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPLOYMENT_CONTEXT__RESOURCE_CONTAINER = eINSTANCE.getDeploymentContext_ResourceContainer();

	}

} //DeploymentPackage
