/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape.util;

import edu.kit.ipd.descartes.identifier.util.IdentifierValidator;

import edu.kit.ipd.descartes.mm.resourcelandscape.*;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage
 * @generated
 */
public class ResourcelandscapeValidator extends EObjectValidator {
	/**
     * The cached model package
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final ResourcelandscapeValidator INSTANCE = new ResourcelandscapeValidator();

	/**
     * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see org.eclipse.emf.common.util.Diagnostic#getSource()
     * @see org.eclipse.emf.common.util.Diagnostic#getCode()
     * @generated
     */
	public static final String DIAGNOSTIC_SOURCE = "edu.kit.ipd.descartes.mm.resourcelandscape";

	/**
     * A constant with a fixed name that can be used as the base value for additional hand written constants.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
     * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
     * The cached base package validator.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected IdentifierValidator identifierValidator;

	/**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ResourcelandscapeValidator() {
        super();
        identifierValidator = IdentifierValidator.INSTANCE;
    }

	/**
     * Returns the package of this validator switch.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EPackage getEPackage() {
      return ResourcelandscapePackage.eINSTANCE;
    }

	/**
     * Calls <code>validateXXX</code> for the corresponding classifier of the model.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
        switch (classifierID) {
            case ResourcelandscapePackage.COMPUTING_INFRASTRUCTURE:
                return validateComputingInfrastructure((ComputingInfrastructure)value, diagnostics, context);
            case ResourcelandscapePackage.NETWORKING_INFRASTRUCTURE:
                return validateNetworkingInfrastructure((NetworkingInfrastructure)value, diagnostics, context);
            case ResourcelandscapePackage.STORAGE_INFRASTRUCTURE:
                return validateStorageInfrastructure((StorageInfrastructure)value, diagnostics, context);
            case ResourcelandscapePackage.CONTAINER:
                return validateContainer((Container)value, diagnostics, context);
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT:
                return validateRuntimeEnvironment((RuntimeEnvironment)value, diagnostics, context);
            case ResourcelandscapePackage.DATA_CENTER:
                return validateDataCenter((DataCenter)value, diagnostics, context);
            case ResourcelandscapePackage.DISTRIBUTED_DATA_CENTER:
                return validateDistributedDataCenter((DistributedDataCenter)value, diagnostics, context);
            case ResourcelandscapePackage.COMPOSITE_HARDWARE_INFRASTRUCTURE:
                return validateCompositeHardwareInfrastructure((CompositeHardwareInfrastructure)value, diagnostics, context);
            case ResourcelandscapePackage.HARDWARE_INFRASTRUCTURE:
                return validateHardwareInfrastructure((HardwareInfrastructure)value, diagnostics, context);
            default:
                return true;
        }
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateComputingInfrastructure(ComputingInfrastructure computingInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(computingInfrastructure, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(computingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(computingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(computingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(computingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(computingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(computingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(computingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(computingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(computingInfrastructure, diagnostics, context);
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateNetworkingInfrastructure(NetworkingInfrastructure networkingInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(networkingInfrastructure, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(networkingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(networkingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(networkingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(networkingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(networkingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(networkingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(networkingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(networkingInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(networkingInfrastructure, diagnostics, context);
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateStorageInfrastructure(StorageInfrastructure storageInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(storageInfrastructure, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(storageInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(storageInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(storageInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(storageInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(storageInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(storageInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(storageInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(storageInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(storageInfrastructure, diagnostics, context);
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateContainer(Container container, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(container, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(container, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(container, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(container, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(container, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(container, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(container, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(container, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(container, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(container, diagnostics, context);
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateRuntimeEnvironment(RuntimeEnvironment runtimeEnvironment, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(runtimeEnvironment, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(runtimeEnvironment, diagnostics, context);
        if (result || diagnostics != null) result &= validateRuntimeEnvironment_runtimeEnvironmentLevelCompliance(runtimeEnvironment, diagnostics, context);
        return result;
    }

	/**
     * The cached validation expression for the runtimeEnvironmentLevelCompliance constraint of '<em>Runtime Environment</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected static final String RUNTIME_ENVIRONMENT__RUNTIME_ENVIRONMENT_LEVEL_COMPLIANCE__EEXPRESSION = "self.containedIn.contains->forAll(r : RuntimeEnvironment | r.ofClass = self.ofClass)";

	/**
     * Validates the runtimeEnvironmentLevelCompliance constraint of '<em>Runtime Environment</em>'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateRuntimeEnvironment_runtimeEnvironmentLevelCompliance(RuntimeEnvironment runtimeEnvironment, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return
            validate
                (ResourcelandscapePackage.Literals.RUNTIME_ENVIRONMENT,
                 runtimeEnvironment,
                 diagnostics,
                 context,
                 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
                 "runtimeEnvironmentLevelCompliance",
                 RUNTIME_ENVIRONMENT__RUNTIME_ENVIRONMENT_LEVEL_COMPLIANCE__EEXPRESSION,
                 Diagnostic.ERROR,
                 DIAGNOSTIC_SOURCE,
                 0);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateDataCenter(DataCenter dataCenter, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(dataCenter, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(dataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(dataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(dataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(dataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(dataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(dataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(dataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(dataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(dataCenter, diagnostics, context);
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateDistributedDataCenter(DistributedDataCenter distributedDataCenter, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(distributedDataCenter, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(distributedDataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(distributedDataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(distributedDataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(distributedDataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(distributedDataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(distributedDataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(distributedDataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(distributedDataCenter, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(distributedDataCenter, diagnostics, context);
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean validateCompositeHardwareInfrastructure(CompositeHardwareInfrastructure compositeHardwareInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(compositeHardwareInfrastructure, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(compositeHardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(compositeHardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(compositeHardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(compositeHardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(compositeHardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(compositeHardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(compositeHardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(compositeHardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(compositeHardwareInfrastructure, diagnostics, context);
        return result;
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateHardwareInfrastructure(HardwareInfrastructure hardwareInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
        if (!validate_NoCircularContainment(hardwareInfrastructure, diagnostics, context)) return false;
        boolean result = validate_EveryMultiplicityConforms(hardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryDataValueConforms(hardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(hardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(hardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryProxyResolves(hardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_UniqueID(hardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryKeyUnique(hardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(hardwareInfrastructure, diagnostics, context);
        if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(hardwareInfrastructure, diagnostics, context);
        return result;
    }

    /**
     * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public ResourceLocator getResourceLocator() {
        // TODO
        // Specialize this to return a resource locator for messages specific to this validator.
        // Ensure that you remove @generated or mark it @generated NOT
        return super.getResourceLocator();
    }

} //ResourcelandscapeValidator
